<?php

namespace Schaffen\SerasaRemessa\Http\Advanced\PJ\SubTypes\F900;

use Schaffen\SerasaRemessa\Utils\Record;
use Schaffen\SerasaRemessa\Utils\RecordColumn;
use Schaffen\SerasaRemessa\Utils\Util;

class SubTypeRECA_4 extends Record {
    public $name = "riskscoring_value_calc";
    
    public $templateColumns = [
        [
            'name' => "type_rule",
            'position' => 1,
            'size' => 4,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "cod_cons",
            'position' => 5,
            'size' => 4,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "subtipo",
            'position' => 9,
            'size' => 2,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "perfx5",
            'position' => 11,
            'size' => 5,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "valfx5",
            'position' => 16,
            'size' => 17,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "pertot",
            'position' => 33,
            'size' => 5,
            'type' =>  RecordColumn::TYPE_NUMERIC,
        ],
        [
            'name' => "valtot",
            'position' => 38,
            'size' => 17,
            'type' =>  RecordColumn::TYPE_NUMERIC,
        ],
        [
            'name' => "filler",
            'position' => 55,
            'size' => 61,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
    ];

    public function __construct($values = null) {
        $this->createColumns();
        
        if($values !== null) {
            $this->setValues($values);
        }
    }

    public function setValues($values) {
        $newValues = $this->getValues();
        
        $newValues['type_rule'] = substr($values, 0, 4);
        $newValues['cod_cons'] = substr($values, 4, 4);
        $newValues['subtipo'] = substr($values, 8, 2);
        $newValues['perfx5'] = substr($values, 10, 5);
        $newValues['valfx5'] = substr($values, 15, 17);
        $newValues['pertot'] = substr($values, 32, 5);
        $newValues['valtot'] = substr($values, 37, 17);
        $newValues['filler'] = substr($values, 54, 61);

        
        $this->setColumnsValues($newValues);
    }
}