<?php

namespace Schaffen\SerasaRemessa\Http\Advanced\PJ\SubTypes\F900;

use Schaffen\SerasaRemessa\Utils\Record;
use Schaffen\SerasaRemessa\Utils\RecordColumn;
use Schaffen\SerasaRemessa\Utils\Util;

class SubTypesREM1_1 extends Record {
    public $name = "spc";

    public $templateColumns = [
        [
            'name' => "type_rule",
            'position' => 1,
            'size' => 4,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "cod_cons",
            'position' => 5,
            'size' => 4,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "subtip",
            'position' => 9,
            'size' => 2,
            'type' =>  RecordColumn::TYPE_NUMERIC,
        ],
        [
            'name' => "dt_atlz",
            'position' => 11,
            'size' => 10,
            'type' =>  RecordColumn::TYPE_NUMERIC,
        ],
        [
            'name' => "raiz",
            'position' => 21,
            'size' => 8,
            'type' =>  RecordColumn::TYPE_NUMERIC,
        ],
        [
            'name' => "fili",
            'position' => 29,
            'size' => 4,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "digi",
            'position' => 33,
            'size' => 2,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "rzsoc",
            'position' => 35,
            'size' => 70,
            'type' =>  RecordColumn::TYPE_NUMERIC,
        ],
    ];

    public function __construct($values = null) {
        $this->createColumns();
        
        if($values !== null) {
            $this->setValues($values);
        }
    }

    public function setValues($values) {
        $newValues = $this->getValues();
        
        $newValues['type_rule'] = substr($values, 0, 4);
        $newValues['cod_cons'] = substr($values, 4, 4);
        $newValues['subtip'] = substr($values, 8, 2);
        $newValues['dt_atlz'] = substr($values, 10, 10);
        $newValues['raiz'] = substr($values, 20, 8);
        $newValues['fili'] = substr($values, 28, 4);
        $newValues['digi'] = substr($values, 32, 2);
        $newValues['rzsoc'] = substr($values, 34, 70);
        
        $this->setColumnsValues($newValues);
    }
}